Bug 53686 - Status "501 Not Implemented" sent very late
Summary: Status "501 Not Implemented" sent very late
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: Core (show other bugs)
Version: 2.2.22
Hardware: PC All
: P2 enhancement (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate, PatchAvailable
Depends on:
Blocks:
 
Reported: 2012-08-09 15:47 UTC by Carsten Gaebler
Modified: 2018-11-07 21:09 UTC (History)
0 users



Attachments
Return 501 for invalid methods as soon as the headers have been read (731 bytes, patch)
2012-08-10 15:23 UTC, Carsten Gaebler
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Carsten Gaebler 2012-08-09 15:47:54 UTC
Is there any reason why HTTP_NOT_IMPLEMENTED is returned to the client rather late by default_handler() in server/core.c instead of having it handled by ap_read_request() in server/protocol.c?

The way it is now causes Apache to unnecessarily dive down into the document root, reading .htaccess files, stat()ing index documents etc. Moving it to ap_read_request() would avoid that overhead.

NB, this might be related to Bug 51201.
Comment 1 Eric Covener 2012-08-09 16:00:56 UTC
(In reply to comment #0)
> Is there any reason why HTTP_NOT_IMPLEMENTED is returned to the client
> rather late by default_handler() in server/core.c instead of having it
> handled by ap_read_request() in server/protocol.c?
> 
> The way it is now causes Apache to unnecessarily dive down into the document
> root, reading .htaccess files, stat()ing index documents etc. Moving it to
> ap_read_request() would avoid that overhead.
> 
> NB, this might be related to Bug 51201.

Modules need some way to have a look at a request incl. method to see if they're willing to handle it, it could be done "earlier" in a new hook, but those modules would probably want their per-directory config completed and maybe even know what file the request mapped to before deciding.
Comment 2 Carsten Gaebler 2012-08-09 16:38:05 UTC
This bug is not about deciding whether or not a request method is valid for the requested resource. It's about deciding whether or not a request method is valid in the first place.

Modules register any additional methods at startup, don't they? So any method not registered at startup and therefore not known to Apache could be rejected right after reading the headers (unless there is a way to register methods at runtime).
Comment 3 Eric Covener 2012-08-09 16:52:50 UTC
(In reply to comment #2)
> This bug is not about deciding whether or not a request method is valid for
> the requested resource. It's about deciding whether or not a request method
> is valid in the first place.
> 
> Modules register any additional methods at startup, don't they? So any
> method not registered at startup and therefore not known to Apache could be
> rejected right after reading the headers (unless there is a way to register
> methods at runtime).

yes -- startup only.  I think it's fair, but reclassifying as enhancement
Comment 4 Carsten Gaebler 2012-08-10 15:23:59 UTC
Created attachment 29210 [details]
Return 501 for invalid methods as soon as the headers have been read

I have created a patch that checks for invalid request methods in ap_read_request().
Comment 5 Carsten Gaebler 2012-11-10 09:40:11 UTC
Any chance to see this in the next release?
Comment 6 Carsten Gaebler 2014-03-17 21:31:48 UTC
Ping?
Comment 7 William A. Rowe Jr. 2018-11-07 21:09:20 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.